Index: /js/viewer-f0/js/NeuronDrawer.js
===================================================================
--- /js/viewer-f0/js/NeuronDrawer.js	(revision 207)
+++ /js/viewer-f0/js/NeuronDrawer.js	(revision 208)
@@ -1,162 +1,188 @@
-function NeuronDrawer(context) {
-    this._scene = undefined;
-    this._camera = undefined;
-    this._renderer = undefined;
-    this._canvasWidth = 400;
-    this._canvasHeight = 400;
-    this._containerContext = context;
-    this._controls = undefined;
-    this._showAxis = false;
+function NeuronDrawer(contextName, width, height) {
+    this._canvasWidth = width;
+    this._canvasHeight = height;
+    this._containerContextName = contextName;
     this._unknown_symbol=[1,4, 25,25, 75,25, 75,75, 25,75, 25,25];
     this._neuron_symbol=[1,4, 75,50, 25,0, 25,99, 75,50, 100,50];
     this._inputonly_symbol=[1,5, 25,40, 35,40, 45,50, 35,60, 25,60, 25,40];
     this._outputonly_symbol=[1,7, 75,50, 75,60, 55,60, 65,50, 55,40, 75,40, 75,50, 100,50];
-    this._canvas = undefined;
     this._neurons = undefined;
-}
-
-NeuronDrawer.prototype.initialize = function () {
-
-
-    //this._canvas = document.getElementById("containerNeuron");
-    /*
-    if (this._canvas.getContext){
-
-        // use getContext to use the canvas for drawing
-        var ctx = this._canvas.getContext('2d');
-
-        var lastX=this._canvas.width/2, lastY=this._canvas.height/2;
-        var dragStart,dragged;
-        this._canvas.addEventListener('mousedown',function(evt){
-            document.body.style.mozUserSelect = document.body.style.webkitUserSelect = document.body.style.userSelect = 'none';
-            lastX = evt.offsetX || (evt.pageX - canvas.offsetLeft);
-            lastY = evt.offsetY || (evt.pageY - canvas.offsetTop);
-            dragStart = ctx.transformedPoint(lastX,lastY);
-            dragged = false;
-        },false);
-
-        this._canvas.addEventListener('mousemove',function(evt){
-            lastX = evt.offsetX || (evt.pageX - this._canvas.offsetLeft);
-            lastY = evt.offsetY || (evt.pageY - this._canvas.offsetTop);
-            dragged = true;
-            if (dragStart){
-                var pt = ctx.transformedPoint(lastX,lastY);
-                ctx.translate(pt.x-dragStart.x,pt.y-dragStart.y);
-                redraw();
-            }
-        },false);
-        this._canvas.addEventListener('mouseup',function(evt){
-            dragStart = null;
-            if (!dragged) zoom(evt.shiftKey ? -1 : 1 );
-        },false);
-
-        // Filled triangle
-        ctx.beginPath();
-        ctx.moveTo(25,25);
-        ctx.lineTo(105,25);
-        ctx.lineTo(25,105);
-        ctx.fill();
-
-        // Stroked triangle
-        ctx.beginPath();
-        ctx.moveTo(125,125);
-        ctx.lineTo(125,45);
-        ctx.lineTo(45,125);
-        ctx.closePath();
-        ctx.stroke();
-
-    }
-    else
-        alert("dupa");
-    //this._debug();*/
-}
-
-
-NeuronDrawer.prototype.showPartAxis = function () {
-    this._showAxis = true;
-}
-
-NeuronDrawer.prototype._createRenderer = function () {
-    this._renderer = new THREE.CanvasRenderer();//WebGLRenderer({antialias: true});
-    this._renderer.setClearColor(0xffffff, 1);
-    this._renderer.setSize(this._canvasWidth, this._canvasHeight);
-    //this._containerContext = $("#containerNeuron");
-    this._containerContext.append(this._renderer.domElement);
-}
-
-NeuronDrawer.prototype._prepareCamera = function () {
-    this._camera = new THREE.PerspectiveCamera(45, this._canvasWidth / this._canvasHeight, 1, 10000);
-    this._camera.position.set(0, 0, 10);
-    this._camera.lookAt(this._scene.position);
-    this._scene.add(this._camera);
-}
-
-NeuronDrawer.prototype._addLight = function () {
-    var directionalLight = new THREE.DirectionalLight(0xffffff);
-
-    directionalLight.position = this._camera.position;
-    directionalLight.intensity = 1;
-
-    this._scene.add(directionalLight);
-}
-
-NeuronDrawer.prototype.initializeScene = function () {
-
-    this._createRenderer();
-    this._scene = new THREE.Scene();
-    this._prepareCamera();
-    this._addLight();
-    this._controls = new THREE.TrackballControls(this._camera, this._renderer.domElement)
-    this._debug();
-}
-
-NeuronDrawer.prototype.renderScene = function () {
-
+    this._SCALE = 150;
+    this._scale = 1;
+    this._min_scale = 0.1;
+    //Kinetic.js
+    this._stage = undefined;
+    this._layer = undefined;
+}
+
+NeuronDrawer.prototype.initializeNewCanvas = function () {
+
+    this._stage = new Kinetic.Stage({
+        container: this._containerContextName,
+        width: this._canvasWidth,
+        height: this._canvasHeight,
+        draggable: true
+    });
+
+    this._layer = new Kinetic.Layer();
+
+    this._addZoom();
+}
+
+NeuronDrawer.prototype._addZoom = function(){
     var self = this;
-    requestAnimationFrame(
-        function () {
-            self.renderScene();
-        });
-    this._renderer.render(this._scene, this._camera);
-    this._controls.update();
-
-}
-
-NeuronDrawer.prototype._debug = function () {
-    this._scene.add(new THREE.AxisHelper(20));
+
+    var isFirefox = (/Firefox/i.test(navigator.userAgent)) ? true : false;
+
+    var mousewheelevt= isFirefox ? "DOMMouseScroll" : "mousewheel" //FF doesn't recognize mousewheel as of FF3.x
+
+    document.getElementById(this._containerContextName).addEventListener(mousewheelevt,function(e){
+        e.preventDefault();
+
+        var zoomAmount = 0;
+        if(!isFirefox)
+            zoomAmount = e.wheelDelta * 0.001;
+        else
+            zoomAmount = e.detail * -0.12;
+
+        var newScale = self._stage.scale();
+        newScale.x += zoomAmount;
+        newScale.y += zoomAmount;
+
+        self._stage.scale(newScale)
+        self._stage.draw();
+    });
+}
+
+NeuronDrawer.prototype.drawNeuralNetwork = function (neurons, connections, layouts, classes) {
+
+    this._neurons = [];
+    var offsetFactor = 0;
+
+    for (var i = 0; i < layouts.length; i++) {
+        var scheme = undefined;
+        scheme = this._chooseSchema(i,neurons, connections, classes);
+
+        var neuronData = this._getSize(scheme);
+        neuronData.scheme = scheme;
+        neuronData.x += layouts[i].x * this._SCALE;
+        neuronData.y += -layouts[i].y * this._SCALE;
+
+        this._neurons.push(neuronData);
+        this.drawNeuron(layouts[i].x * this._SCALE, -layouts[i].y * this._SCALE, scheme);
+
+        offsetFactor = Math.min(offsetFactor, layouts[i].x);
+    }
+
+    this._layer.offsetX(offsetFactor * this._SCALE);
+
+    for (var i = 0; i < connections.length; i++)
+        this.drawConnection(i, neurons, connections, einfos);
 }
 
 NeuronDrawer.prototype.drawNeuron = function (x, y, scheme) {
-
-
-    var obj = new THREE.Object3D();
-
-    var material = new THREE.LineBasicMaterial({
-        color: 0x0000ff
-    });
+    var points = [];
+
     var position = 0;
-    var noOfBlocks = 0;//number of "blocks" to draw
+    var noOfBlocks = scheme[position++];//number of "blocks" to draw
     var noOfLines = 0;//number of line to draw
-    noOfBlocks = scheme[position++];
     for (var i = 0; i < noOfBlocks; i++) {
         noOfLines = scheme[position++];
 
         for (var j = 0; j < noOfLines; j++) {
-            var geometry = new THREE.Geometry();
-            geometry.vertices.push(new THREE.Vector3(scheme[position++] + x, scheme[position++] + y, 0));
-            geometry.vertices.push(new THREE.Vector3(scheme[position++] + x, scheme[position++] + y, 0));
-            position = position - 2; //get to last point in list
-            var line = new THREE.Line(geometry, material);
-            obj.add(line);
-        }
-        position = position + 2;//move to value which define number of lines to draw
-    }
-
-    var SCALE = 0.05;
-
-    obj.scale.set(SCALE, SCALE, SCALE);
-    obj.rotateX(Math.PI);//rotate 180 degree
-    //obj.translateY(-5.5);
-    this._scene.add(obj)
+            points.push(scheme[position++]+x);
+            points.push(scheme[position++]+y);
+        }
+
+        points.push(scheme[position++]+x);
+        points.push(scheme[position++]+y);
+
+        var symbol = new Kinetic.Line({
+            points: points,
+            stroke: 'black',
+            strokeWidth: 1
+        });
+
+        symbol.move({x:0, y: 0});
+        var self = this;
+        symbol.on('mousemove', function(){
+            var mousePos = self._stage.getPointerPosition();
+            var x = mousePos.x;
+            var y = mousePos.y;
+            console.log(x,y);
+        });
+
+        this._layer.add(symbol);
+        points = [];
+    }
+}
+
+NeuronDrawer.prototype._getConnection = function(connections, id, number){
+
+    var counter = 0;
+    for(var i = 0; i < connections.length; i++)
+    {
+        if(connections[i].getDestination() == id)
+            {
+            if(counter == number)
+                return connections[i].getSource();
+            else
+                counter++;
+        }
+    }
+}
+
+NeuronDrawer.prototype.drawConnection = function (id, neurons, connections, einfos) {
+
+    var n2;
+    neuroId = connections[id].getDestination();
+    //this is hack trick to change order of inputs
+    var maxVal = this._inputY(this._getNumberOfInputs(neuroId,connections), connections, neuroId);
+
+    for(var input = 0; input < this._getNumberOfInputs(neuroId,connections); input++)
+    {
+        n2 = this._neurons[this._getConnection(connections, neuroId, input)];
+        var points = [];
+
+        var yw = this._inputY(input, connections, neuroId);
+        var xw = (maxVal-yw) / 4;
+
+        yw += this._neurons[neuroId].y;//add position of object to y
+
+        points.push(this._neurons[neuroId].x);//x
+        points.push(yw);//y
+
+        points.push(this._neurons[neuroId].x - xw);//x
+        points.push(yw);//y
+
+        points.push(n2.x+n2.sizeX);
+        points.push(n2.y + n2.sizeY/2);
+
+        /*if(diagram?)
+        {
+            //straight forward
+        }
+        else
+        {
+            //U-shape
+        }*/
+
+        var line = new Kinetic.Line({
+            points: points,
+            stroke: 'black',
+            strokeWidth: 1
+        });
+        this._layer.add(line);
+    }
+
+}
+
+NeuronDrawer.prototype._inputY = function(number, connections, id){
+    return ((1 + number)* this._neurons[id].sizeY) / ((this._getNumberOfInputs(id, connections)) + 1);
+}
+
+NeuronDrawer.prototype.finalize = function()
+{
+    this._stage.add(this._layer);
 }
 
@@ -184,164 +210,5 @@
 }
 
-NeuronDrawer.prototype.drawConnection = function (id, neurons, connections, einfos) {
-
-    var n2;
-
-    for(var iw = 0; iw < this._getNumberOfInputs(id,connections); iw++)
-    {
-        n2 = neurons[iw];
-
-        var yw = this._inputY(iw);
-        var xw = yw / 4;
-        this._drawLine()
-    }
-    
-    /*var destination = connections[id].getDestination();
-    var numberOfConnToDest = 0;
-    var numberOfDrawenCon = 0;
-
-    //check how many conenctions have the same destination
-    for (var i = 0; i < connections.length; i++) {
-        if (connections[i].getDestination() == destination)
-            numberOfConnToDest++;
-    }
-
-    //check how many connections had been drawen
-    for (var i = 0; i < id; i++) {
-        if (connections[i].getDestination() == destination)
-            numberOfDrawenCon++;
-    }
-
-    var positionY = (numberOfDrawenCon + 1) * 100 / (numberOfConnToDest + 1);
-    var positionX = (numberOfDrawenCon + 1) * 10 / (numberOfConnToDest + 1);
-
-    var x1 = einfos[connections[id].getDestination()].x;
-    var y1 = einfos[connections[id].getDestination()].y;
-
-    var x2 = einfos[connections[id].getSource()].x;
-    var y2 = einfos[connections[id].getSource()].y;
-
-    var material = new THREE.LineBasicMaterial({
-        color: 0x0000ff
-    });
-
-    var SCALE = 0.05;
-
-    var geometry = new THREE.Geometry();
-    geometry.vertices.push(new THREE.Vector3(100 + x2 * 100, 10 + 50 + y2 * 100, 0));
-    geometry.vertices.push(new THREE.Vector3(10 + 100 + x2 * 100, 10 + 50 + y2 * 100, 0));
-    var line = new THREE.Line(geometry, material);
-    line.scale.set(SCALE, SCALE, SCALE);
-    this._scene.add(line);
-
-
-    var geometry1 = new THREE.Geometry();
-    geometry1.vertices.push(new THREE.Vector3(10 + positionX + x1 * 100, 10 + positionY + y1 * 100, 0));
-    geometry1.vertices.push(new THREE.Vector3(10 + 25 + x1 * 100, 10 + positionY + y1 * 100, 0));
-    var line1 = new THREE.Line(geometry1, material);
-
-    line1.scale.set(SCALE, SCALE, SCALE);
-    this._scene.add(line1);
-
-    //bezposredni poprzednik - to koniec :)
-    if (x1 == x2 + 1)//kazdy polozony w kolumnie po lewej ma jedna ukosna linie
-    {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 10 + positionY + y1 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(110 + x2 * 100, 10 + 50 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-    }
-
-    //pierwszy pionowy
-    if (y1 >= y2) {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(110 + (x2 * 100), 60 + y2 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(110 + (x2 * 100), 105 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-    }
-
-    else {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(110 + (x2 * 100), 60 + y2 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(110 + (x2 * 100), 15 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-    }
-
-
-    //poziomy
-    if (y1 >= y2) {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(110 + (x2 * 100), 105 + y2 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 105 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-        //g.drawLine((int) ((110 + (x2 * 100)) * zoom), (int) ((105 + y2 * 100) * zoom), (int) ((10 + polozenieX + (x1 * 100)) * zoom), (int) ((105 + y2 * 100) * zoom));
-    }
-    else {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(110 + (x2 * 100), 15 + y2 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 15 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-        //g.drawLine((int) ((110 + (x2 * 100)) * zoom), (int) ((15 + y2 * 100) * zoom), (int) ((10 + polozenieX + (x1 * 100)) * zoom), (int) ((15 + y2 * 100) * zoom));
-    }
-
-
-    //drugi pionowy
-    if (y1 >= y2) {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 10 + positionY + y1 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 105 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-        //g.drawLine((int) ((10 + polozenieX + (x1 * 100)) * zoom), (int) ((10 + polozenieY + y1 * 100) * zoom), (int) ((10 + polozenieX + (x1 * 100)) * zoom), (int) ((105 + y2 * 100) * zoom));
-    }
-    else {
-        var geometry = new THREE.Geometry();
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 10 + positionY + y1 * 100, 0));
-        geometry.vertices.push(new THREE.Vector3(10 + positionX + (x1 * 100), 15 + y2 * 100, 0));
-        var line = new THREE.Line(geometry, material);
-        line.scale.set(SCALE, SCALE, SCALE);
-        this._scene.add(line);
-        return;
-        //g.drawLine((int) ((10 + polozenieX + (x1 * 100)) * zoom), (int) ((10 + polozenieY + y1 * 100) * zoom), (int) ((10 + polozenieX + (x1 * 100)) * zoom), (int) ((15 + y2 * 100) * zoom));
-    }
-*/
-}
-
-NeuronDrawer.prototype._inputY = function(number, connections){
-    return (1 + number)*this._neurons[number].sizeY / ((this._getNumberOfInputs(number, connections)) + 1);
-}
-
-NeuronDrawer.prototype._drawLine = function(x1, y1, x2, y2){
-    var geometry = new THREE.Geometry();
-    geometry.vertices.push(new THREE.Vector3(x1, y1, 0));
-    geometry.vertices.push(new THREE.Vector3(x2, y2, 0));
-
-    var material = new THREE.LineBasicMaterial({
-        color: 0x0000ff
-    });
-
-    var SCALE = 1;
-
-    var line = new THREE.Line(geometry, material);
-    line.scale.set(SCALE, SCALE, SCALE);
-    this._scene.add(line);
-}
+
 
 NeuronDrawer.prototype._chooseSchema = function(number, neurons, connections, classes)
@@ -368,9 +235,17 @@
 NeuronDrawer.prototype._getSize = function(scheme)
 {
-    var neuron = {sizeX: 0, sizeY: 0};
+    var neuron = {sizeX: 0, sizeY: 0, x: 0, y: 0};
+
+
+    var minX = Number.MAX_VALUE;
+    var maxX = -1;
+
+    var minY = Number.MAX_VALUE;
+    var maxY = -1;
+
     var position = 0;
-    var noOfBlocks = 0;//number of "blocks" to draw
+    var noOfBlocks = scheme[position++];//number of "blocks" to draw
     var noOfLines = 0;//number of line to draw
-    noOfBlocks = scheme[position++];
+
     for (var i = 0; i < noOfBlocks; i++) {
         noOfLines = scheme[position++];
@@ -378,16 +253,28 @@
         for (var j = 0; j < noOfLines; j++) {
 
-            if(scheme[position] > neuron.sizeX)
-                neuron.sizeX = scheme[position];
-            position++;
-            if(scheme[position] > neuron.sizeY)
-                neuron.sizeY = scheme[position];
-            position++;
-
-            if(scheme[position] > neuron.sizeX)
-                neuron.sizeX = scheme[position];
-            position++;
-            if(scheme[position] > neuron.sizeY)
-                neuron.sizeY = scheme[position];
+
+            if(scheme[position] > maxX)
+                maxX = scheme[position];
+            if(scheme[position] < minX)
+                minX = scheme[position];
+            position++;
+
+            if(scheme[position] > maxY)
+                maxX = scheme[position];
+            if(scheme[position] < minY)
+                minY = scheme[position];
+            position++;
+
+
+            if(scheme[position] > maxX)
+                maxX = scheme[position];
+            if(scheme[position] < minX)
+                minX = scheme[position];
+            position++;
+
+            if(scheme[position] > maxY)
+                maxY = scheme[position];
+            if(scheme[position] < minY)
+                minY = scheme[position];
             position++;
 
@@ -395,29 +282,9 @@
         }
         position = position + 2;//move to value which define number of lines to draw
+        neuron.sizeX = maxX - minX;
+        neuron.sizeY = maxY - minY;
+        neuron.x = minX;
+        neuron.y = minY;
     }
     return neuron;
 }
-
-NeuronDrawer.prototype.drawNetwork = function (neurons, connections, layouts, classes) {
-
-    this._neurons = [];
-
-    for (var i = 0; i < layouts.length; i++) {
-        var scheme = undefined;
-
-        scheme = this._chooseSchema(i,neurons, connections, classes)
-        var neuronData = this._getSize(scheme);
-        neuronData.scheme = scheme;
-        this._neurons.push(neuronData);
-        this.drawNeuron(layouts[i].x * 100  , -layouts[i].y * 100 , scheme);
-    }
-
-    //for (var i = 0; i < connections.length; i++)
-    //    this.drawConnection(i, neurons, connections, einfos);
-}
-
-
-NeuronDrawer.prototype.debugTest = function () {
-
-}
-
Index: /js/viewer-f0/js/SmartLayout.js
===================================================================
--- /js/viewer-f0/js/SmartLayout.js	(revision 207)
+++ /js/viewer-f0/js/SmartLayout.js	(revision 208)
@@ -79,5 +79,5 @@
     if (first) // at this stage we have a single block containing all neurons
     {
-        console.log(" - - setting coordinates - -\n");
+        //console.log(" - - setting coordinates - -\n");
         var i;
         first.createMap();
@@ -85,5 +85,5 @@
         {
             el = first.elements[i];
-            console.log(el, einfos[el].x * 70, -1 * einfos[el].y * 70);
+            //console.log(el, einfos[el].x * 70, -1 * einfos[el].y * 70);
         }
         delete first;
Index: /js/viewer-f0/js/Viewer.js
===================================================================
--- /js/viewer-f0/js/Viewer.js	(revision 207)
+++ /js/viewer-f0/js/Viewer.js	(revision 208)
@@ -12,5 +12,5 @@
     this._neuronsContext = undefined;
     this._context = undefined;
-    this._urlToXML = "http://www.framsticks.com/files/apps/config/f0def.xml";
+    this._urlToXML = 'f0def.xml';//"http://www.framsticks.com/files/apps/config/f0def.xml";
     this._xml = undefined;
     this._model = new Model();
@@ -29,15 +29,14 @@
     this.downloadXML();
     this.parseGeneXml();
-}
-
-Viewer.prototype.showVisualization = function(value, context){
-    this._showVisualization = value;
-    this._visualizationContext = context;
-}
-
-Viewer.prototype.showNeuron = function(value, context)
-{
-     this._showNeurons = true;
-     this._neuronsContext = context;
+    this.VisualizationSettings = {
+        context: undefined,
+        width: undefined,
+        height: undefined
+    };
+    this.NetworkSettings = {
+        context: undefined,
+        width: undefined,
+        height: undefined
+    };
 }
 
@@ -165,5 +164,4 @@
 };
 
-
 Viewer.prototype._getCreatureFromLink = function (link) {
     var lines = undefined;
@@ -239,22 +237,9 @@
 };
 
-Viewer.prototype.mainLoop = function () {
-    this._graphicsEngine.initializeScene();
-    this.renderCreature();
-    this._graphicsEngine.debugTest();
-    this._graphicsEngine.renderScene();
-
-    this._neuronDrawer.initializeScene();
-    new SmartLayout(this._neurons, this._neuroConns);
-    this._neuronDrawer.drawNetwork(this._neurons, this._neuroConns, einfos, this._neuroClasses);
-    this._neuronDrawer.renderScene();
-
-};
-
 Viewer.prototype.run = function (mode, content) {
     this.parseCreature(mode, content);
 
-    if (this._showVisualization) {
-        this._graphicsEngine = new GraphicsEngine(this._visualizationContext)
+    if (this.VisualizationSettings.context) {
+        this._graphicsEngine = new GraphicsEngine(this.VisualizationSettings.context, this.VisualizationSettings.width, this.VisualizationSettings.height);
         this._graphicsEngine.initializeScene();
         this.renderCreature();
@@ -262,10 +247,16 @@
         this._graphicsEngine.renderScene();
     }
-    if (this._showNeurons) {
-        this._neuronDrawer = new NeuronDrawer(this._neuronsContext);
+    if (this.NetworkSettings.context) {
+        this._neuronDrawer = new NeuronDrawer(this.NetworkSettings.context, this.NetworkSettings.width, this.NetworkSettings.height );
+        this._neuronDrawer.initializeNewCanvas();
+        new SmartLayout(this._neurons, this._neuroConns);
+        this._neuronDrawer.drawNeuralNetwork(this._neurons, this._neuroConns, einfos, this._neuroClasses);
+        this._neuronDrawer.finalize();
+
+        /*this._neuronDrawer = new NeuronDrawer(this._neuronsContext);
         this._neuronDrawer.initializeScene();
         new SmartLayout(this._neurons, this._neuroConns);
-        this._neuronDrawer.drawNetwork(this._neurons, this._neuroConns, einfos, this._neuroClasses);
-        this._neuronDrawer.renderScene();
+        this._neuronDrawer.drawNeuralNetwork(this._neurons, this._neuroConns, einfos, this._neuroClasses);
+        this._neuronDrawer.renderScene();*/
     }
 }
@@ -274,6 +265,11 @@
     var viewer = new Viewer();
 
-    viewer.showVisualization(true, $("#container"));
-    viewer.showNeuron(true, $("#containerNeuron"));
+    viewer.VisualizationSettings.context = $("#container");
+    viewer.VisualizationSettings.width = 400;
+    viewer.VisualizationSettings.height = 400;
+
+    viewer.NetworkSettings.context =  "containerNeuron";
+    viewer.NetworkSettings.width = 400;
+    viewer.NetworkSettings.height = 400;
     viewer.run(viewer.Mode.TEXTAREA, $("#geno"));
 }
@@ -281,6 +277,11 @@
 function openEmbeddedCreature() {
     var viewer = new Viewer();
-    viewer.showVisualization(true, $("#container1"));
-    viewer.showNeuron(true, $("#containerNeuron1"));
+    viewer.VisualizationSettings.context = $("#container1");
+    viewer.VisualizationSettings.width = 400;
+    viewer.VisualizationSettings.height = 400;
+
+    viewer.NetworkSettings.context =  "containerNeuron1";
+    viewer.NetworkSettings.width = 400;
+    viewer.NetworkSettings.height = 400;
     viewer.run(viewer.Mode.EMBEDDED, "http://ec.framsticks.com/www/index.php?PAGE=view_genotype&ID=55");
 }
@@ -288,7 +289,10 @@
 function openCodeCreature() {
     var viewer = new Viewer();
-
-    viewer.showVisualization(true, $("#container2"));
-    viewer.showNeuron(true, $("#containerNeuron2"));
+    viewer.VisualizationSettings.context = $("#container2");
+    viewer.VisualizationSettings.width = 400;
+    viewer.VisualizationSettings.height = 400;
+    viewer.NetworkSettings.context =  "containerNeuron2";
+    viewer.NetworkSettings.width = 400;
+    viewer.NetworkSettings.height = 400;
     viewer.run(viewer.Mode.CODE, "//0\np:\np: x=1");
 }
@@ -296,8 +300,13 @@
 function openFileCreature() {
     var viewer = new Viewer();
-
-    var debugCreatureName = "example4";
-    viewer.showVisualization(true, $("#container3"));
-    viewer.showNeuron(true, $("#containerNeuron3"));
+    //var debugCreatureName = "example4";
+    //var debugCreatureName = "caterpillar";
+    var debugCreatureName = "Quadro";
+    //viewer.VisualizationSettings.context = $("#container3");
+    //viewer.VisualizationSettings.width = 400;
+    //viewer.VisualizationSettings.height = 400;
+    viewer.NetworkSettings.context =  "containerNeuron3";
+    viewer.NetworkSettings.width = 400;
+    viewer.NetworkSettings.height = 400;
     viewer.run(viewer.Mode.LINK, "http://localhost:63343/FramestickFavi/creatures/" + debugCreatureName + ".txt");
 }
Index: /js/viewer-f0/js/graphicsEngine.js
===================================================================
--- /js/viewer-f0/js/graphicsEngine.js	(revision 207)
+++ /js/viewer-f0/js/graphicsEngine.js	(revision 208)
@@ -1,9 +1,9 @@
-function GraphicsEngine(context) {
+function GraphicsEngine(context, width, height) {
     this._scene = undefined;
     this._camera = undefined;
     this._renderer = undefined;
-    this._canvasWidth = 400;
-    this._canvasHeight = 400;
-    this._containerContext = context;
+    this._canvasWidth = width;
+    this._canvasHeight = height;
+    this._containerContextName = context;
     this._BALL_RADIUS = 0.25;
     this._controls = undefined;
@@ -11,4 +11,5 @@
     this._debug1 = 0
     this._showAxis = false;
+    this._render = true;
 }
 
@@ -21,6 +22,10 @@
     this._renderer.setClearColor(0x000000, 1);
     this._renderer.setSize(this._canvasWidth, this._canvasHeight);
-    //this._containerContext = $("#container");
-    this._containerContext.append(this._renderer.domElement);
+    this._containerContextName.append(this._renderer.domElement);
+
+    var self = this;
+    this._renderer.domElement.addEventListener('mousemove', function(evt){
+        self._render = true;
+    });
 }
 
@@ -138,5 +143,5 @@
 
 GraphicsEngine.prototype.addPart = function (part) {
-    console.log(part.getX(),part.getY(),part.getZ(), "|", part.getXshape(),part.getYshape(),part.getZshape(),"|",part.getXrot(),part.getYrot(),part.getZrot())
+    //console.log(part.getX(),part.getY(),part.getZ(), "|", part.getXshape(),part.getYshape(),part.getZshape(),"|",part.getXrot(),part.getYrot(),part.getZrot())
     switch (part.getType()) {
         case 0:
@@ -257,13 +262,18 @@
             self.renderScene();
         });
+
+    if(!this._render)
+    {
+        return;
+    }
+
     this._renderer.render(this._scene, this._camera);
     this._controls.update();
-
+    this._render = false;
 }
 
 GraphicsEngine.prototype._debug = function()
 {
-
-    this._scene.add( new THREE.AxisHelper( 20 ) );
+    this._scene.add(new THREE.AxisHelper( 20 ));
 }
 
